package ZMEM1;

//   ZMEM1:     Memento ,         :
// Stanje: prvo stanje
// Stanje: drugo stanje
// Stanje: prvo stanje


class Memento
{ ...;
  void postaviStanje(String stanje) {...}
  String uzmiStanje() { ...}
}

class Caretaker 
{ 
  Originator orig;
  ...

  Caretaker(Originator orig) {this.orig = orig;}
  void kreirajStanje(String stanje) {...}
  void kreirajKopijuStanja(){ ... = orig.kreirajMemento();}
  String vratiStanje(){return orig.vratiStanje();}
  void vratiKopijuStanja(){...}
  
  public static void main(String args[])
     {   
         Originator or = new Originator();
         Caretaker ct = new Caretaker(or); 
         /* Prvo stanje */
         ct.kreirajStanje("prvo stanje");
         ct.kreirajKopijuStanja(); 
         System.out.println("Stanje: " + ct.vratiStanje());
         
         /* Drugo stanje */
         ct.kreirajStanje("drugo stanje");
         System.out.println("Stanje: " + ct.vratiStanje());
         
         /* Vracanje na prvo stanje */
         ...
         System.out.println("Stanje: " + ct.vratiStanje());
   }
}


class  Originator 
{  
   String stanje;
    
   void kreirajStanje(String stanje) {this.stanje = stanje;}
   
   Memento kreirajMemento()
       {  Memento mem = new Memento();
          ...
          return mem;
       }
   void postaviStanje(Memento mem) {...} 
   
   String vratiStanje(){return stanje;}
}
    


