package RZMEM1;

//   RZMEM1:     Memento ,         :
// Stanje: prvo stanje
// Stanje: drugo stanje
// Stanje: prvo stanje


class Memento
{ String stanje;
  void postaviStanje(String stanje) {this.stanje = stanje;}
  String uzmiStanje() { return stanje;}
}

class Caretaker 
{ 
  Originator orig;
  Memento mem;

  Caretaker(Originator orig) {this.orig = orig;}
  void kreirajStanje(String stanje) {orig.kreirajStanje(stanje);}
  void kreirajKopijuStanja(){ mem = orig.kreirajMemento();}
  String vratiStanje(){return orig.vratiStanje();}
  void vratiKopijuStanja(){orig.postaviStanje(mem);}
  
  public static void main(String args[])
     {   
         Originator or = new Originator();
         Caretaker ct = new Caretaker(or); 
         /* Prvo stanje */
         ct.kreirajStanje("prvo stanje");
         ct.kreirajKopijuStanja(); 
         System.out.println("Stanje: " + ct.vratiStanje());
         
         /* Drugo stanje */
         ct.kreirajStanje("drugo stanje");
         System.out.println("Stanje: " + ct.vratiStanje());
         
         /* Vracanje na prvo stanje */
         ct.vratiKopijuStanja();
         System.out.println("Stanje: " + ct.vratiStanje());
   }
}


class  Originator 
{  
   String stanje;
    
   void kreirajStanje(String stanje) {this.stanje = stanje;}
   
   Memento kreirajMemento()
       {  Memento mem = new Memento();
          mem.postaviStanje(stanje);
          return mem;
       }
   void postaviStanje(Memento mem) {stanje=mem.uzmiStanje();} 
   
   String vratiStanje(){return stanje;}
}
    


